// SPDX-License-Identifier: Apache-2.0
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
import { CommandHandler } from "../../../../../../core/decorator/CommandHandlerDecorator";
import SecurityService from "../../../../../service/security/SecurityService";
import { SetMaxSupplyCommand, SetMaxSupplyCommandResponse } from "./SetMaxSupplyCommand";
import TransactionService from "../../../../../service/transaction/TransactionService";
import { lazyInject } from "../../../../../../core/decorator/LazyInjectDecorator";
import BigDecimal from "../../../../../../domain/context/shared/BigDecimal";
import AccountService from "../../../../../service/account/AccountService";
import ValidationService from "../../../../../service/validation/ValidationService";
import { SecurityRole } from "../../../../../../domain/context/security/SecurityRole";
import ContractService from "../../../../../service/contract/ContractService";
import { SetMaxSupplyCommandError } from "./error/SetMaxSupplyCommandError";
let SetMaxSupplyCommandHandler = class SetMaxSupplyCommandHandler {
    securityService;
    transactionService;
    accountService;
    contractService;
    validationService;
    constructor(securityService, transactionService, accountService, contractService, validationService) {
        this.securityService = securityService;
        this.transactionService = transactionService;
        this.accountService = accountService;
        this.contractService = contractService;
        this.validationService = validationService;
    }
    async execute(command) {
        try {
            const { securityId, maxSupply } = command;
            const handler = this.transactionService.getHandler();
            const account = this.accountService.getCurrentAccount();
            const securityEvmAddress = await this.contractService.getContractEvmAddress(securityId);
            const security = await this.securityService.get(securityId);
            const maxSupplyBd = BigDecimal.fromString(maxSupply, security.decimals);
            await this.validationService.checkRole(SecurityRole._CAP_ROLE, account.id.toString(), securityId);
            await this.validationService.checkDecimals(security, maxSupply);
            const res = await handler.setMaxSupply(securityEvmAddress, maxSupplyBd, securityId);
            return Promise.resolve(new SetMaxSupplyCommandResponse(res.error === undefined, res.id));
        }
        catch (error) {
            throw new SetMaxSupplyCommandError(error);
        }
    }
};
SetMaxSupplyCommandHandler = __decorate([
    CommandHandler(SetMaxSupplyCommand),
    __param(0, lazyInject(SecurityService)),
    __param(1, lazyInject(TransactionService)),
    __param(2, lazyInject(AccountService)),
    __param(3, lazyInject(ContractService)),
    __param(4, lazyInject(ValidationService)),
    __metadata("design:paramtypes", [SecurityService,
        TransactionService,
        AccountService,
        ContractService,
        ValidationService])
], SetMaxSupplyCommandHandler);
export { SetMaxSupplyCommandHandler };
